package com.ruoyi.platform.service;


import com.ruoyi.platform.domain.DatasetVersion;
import com.ruoyi.platform.vo.LabelDatasetVersionVo;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.PageRequest;

import java.util.List;
import java.util.Map;

/**
 * (DatasetVersion)表服务接口
 *
 * @author Xidaray
 * @since 2024-01-03 16:57:12
 */
public interface DatasetVersionService {

    /**
     * 通过ID查询单条数据
     *
     * @param id 主键
     * @return 实例对象
     */
    DatasetVersion queryById(Integer id);

    /**
     * 分页查询
     *
     * @param datasetVersion 筛选条件
     * @param pageRequest      分页对象
     * @return 查询结果
     */
    Page<DatasetVersion> queryByPage(DatasetVersion datasetVersion, PageRequest pageRequest);

    /**
     * 新增数据
     *
     * @param datasetVersion 实例对象
     * @return 实例对象
     */
    DatasetVersion insert(DatasetVersion datasetVersion) throws Exception;

    /**
     * 修改数据
     *
     * @param datasetVersion 实例对象
     * @return 实例对象
     */
    DatasetVersion update(DatasetVersion datasetVersion);

    /**
     * 通过主键删除数据
     *
     * @param id 主键
     * @return 是否成功
     */
    boolean deleteById(Integer id);

    String removeById(Integer id) throws Exception;

    List<DatasetVersion> queryByDatasetId(Integer datasetId);

    DatasetVersion queryByDatasetVersion(DatasetVersion datasetVersion);

    Map<String,Object> queryByDatasetIdAndVersion(Integer datasetId, String version);

    Map<Integer,String> deleteDatasetVersion(Integer datasetId, String version) throws Exception;

    void checkDeclaredVersion(DatasetVersion insert) throws Exception;

    String addDatasetVersions(List<DatasetVersion> datasetVersions) throws Exception;

//    void addDatasetVersionsFromLabel(LabelDatasetVersionVo labelDatasetVersionVo) throws Exception;
}
